VERSION 5.00
Begin VB.Form frmLayered 
   BorderStyle     =   0  'None
   Caption         =   "Layered"
   ClientHeight    =   2745
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4170
   LinkTopic       =   "Form1"
   ScaleHeight     =   183
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   278
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   555
      Left            =   1620
      TabIndex        =   0
      Top             =   780
      Width           =   975
   End
End
Attribute VB_Name = "frmLayered"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim pWidth As Long, pHeight As Long
Dim pActive As Boolean

Public picSkin As StdPicture


Private Sub Form_Activate()
    '
    If Not pActive Then
        pActive = True
        updateLayer
    End If
End Sub

Private Sub Form_Click()
    Unload Me
End Sub

Private Sub Form_Deactivate()
    '
    If pActive Then
        pActive = False
        updateLayer
    End If
End Sub

Private Sub Form_Load()
    Dim lOldStyle As Long
    
    lOldStyle = GetWindowLong(Me.hWnd, GWL_EXSTYLE)
    SetWindowLong Me.hWnd, GWL_EXSTYLE, lOldStyle Or WS_EX_LAYERED
        
        
    'transform the skin picture dimension to pixels
    'our form width and height is based on skin's width & height
    pWidth = Me.ScaleX(picSkin.Width, vbHimetric, vbPixels)
    pHeight = Me.ScaleY(picSkin.Height, vbHimetric, vbPixels)
        
    updateLayer
End Sub

Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Button = vbLeftButton Then
        ReleaseCapture
        SendMessage Me.hWnd, WM_NCLBUTTONDOWN, HTCAPTION, 0&
    End If
End Sub

Private Sub Form_Paint()
    'Debug.Print "Paint"
    updateLayer
End Sub

Private Sub Form_Resize()
    Me.Width = pWidth * Screen.TwipsPerPixelX
    Me.Height = pHeight * Screen.TwipsPerPixelY
End Sub

Private Sub Form_Unload(Cancel As Integer)
    
    Set picSkin = Nothing
End Sub

Private Sub updateLayer()
    Dim ptDest As POINTAPI                      'new window position
    Dim sz As Size                              'new window size
    Dim pt0 As POINTAPI                         'location of dc
    Dim bf As BLENDFUNCTION                     'blend function
    Dim r As RECT
    Dim n As Long
    Dim hdcBack As Long                         'match this device context and update layer using this device context
    Dim hBmpSave As Long                        'save result of selectobject
    
    GetWindowRect Me.hWnd, r
                
    ptDest.X = r.Left
    ptDest.Y = r.Top
        
    sz.cx = pWidth
    sz.cy = pHeight
    
    pt0.X = 0
    pt0.Y = 0
    
    bf.BlendOp = AC_SRC_OVER
    bf.BlendFlags = 0
    
    If pActive Then                             'windows is active (on focus)
        bf.SourceConstantAlpha = 255            'set it full opaque
    Else                                        'windows is not active (lost focus)
        bf.SourceConstantAlpha = 128            'set it 128 value of transparency (50% transparency)
    End If
    
    bf.AlphaFormat = AC_SRC_ALPHA
        
    hdcBack = CreateCompatibleDC(0&)
    hBmpSave = SelectObject(hdcBack, picSkin.Handle)
        
    n = UpdateLayeredWindow(Me.hWnd, hdcBack, ptDest, sz, hdcBack, pt0, 0, bf, ULW_ALPHA)
    
    SelectObject hdcBack, hBmpSave
    DeleteDC hdcBack
End Sub
